"use strict";
import { util } from '../../../util/util.js'
import { fullMap } from '../../../fullMap.js';
import { khcAlert } from '../../../component/alert/khcAlert.js'
let formComponent=null;
let functionMap=new Map();// 使用 Map 来存储多个函数。每个函数都通过 set 方法添加到 Map 中，键是函数名，值是对应的函数。
export function main(jsonConfig) {
    try {
        functionMap.get(jsonConfig.button_method).apply(jsonConfig);
    } catch (error) {
        khcAlert.showSystemError(error.message);
        console.log(error);
    }
}

function fCreate() {
    let jsonConfig=this;
    jsonConfig.formType='create'
    init.call(jsonConfig)
}
functionMap.set('fCreate', fCreate);// 将函数添加到 Map 中

function fEdit() {
    let jsonConfig=this;
    jsonConfig.formType='edit'
    init.call(jsonConfig)
}
functionMap.set('fEdit', fEdit);// 将函数添加到 Map 中

function fFormCreate(){
    let jsonConfig=this;
    jsonConfig.formType='create'
    init.call(jsonConfig)
}
functionMap.set('fFormCreate', fFormCreate);// 将函数添加到 Map 中

function fFormEdit(){
    let jsonConfig=this;
    jsonConfig.formType='edit'
    init.call(jsonConfig)
}
functionMap.set('fFormEdit', fFormEdit);// 将函数添加到 Map 中

function fDetail() {
    let jsonConfig=this;
    jsonConfig.formType='detail'
    init.call(jsonConfig)
}
functionMap.set('fDetail', fDetail);// 将函数添加到 Map 中

let initIsTreeFunc=null;//是否Tree函数（选择是时弹出相应的字段配置）
let initJsFileFunc=null;//initJsFileFunc函数
function init(){
    let jsonConfig=this;
    let objID = jsonConfig.objID;
    let formType = jsonConfig.formType
    formComponent = fullMap.getObj(objID);
    let eleMap=formComponent.getFormMap();
    if((formType==undefined||formType=='undefined')||formType=='create'){
        formComponent.initEleConfig({fieldArray:treeFieldArray,isDisabled:true,isClearValue:false,isShowDiv:false,isCanNull:false})
        formComponent.initEleConfig({fieldArray:jsFieldArray,isDisabled:true,isClearValue:false,isShowDiv:false,isCanNull:false})
    }else if(formType=='edit'){
        initForm(eleMap)//初始化表单的一些限制,或对更改内容添加标注（添加背景颜色代表该字段被更改过）
        if(eleMap.get('is_tree').getValue()=='Y'){
            formComponent.initEleConfig({fieldArray:treeFieldArray,isDisabled:false,isClearValue:false,isShowDiv:true,isCanNull:true})//展示但强制要求必填
        }else{
            formComponent.initEleConfig({fieldArray:treeFieldArray,isDisabled:true,isClearValue:false,isShowDiv:false,isCanNull:false})
        }
        if(eleMap.get('js_file').getValue().length>0){
            formComponent.initEleConfig({fieldArray:jsFieldArray,isDisabled:false,isClearValue:false,isShowDiv:true,isCanNull:false})//展示但不强制要求必填
        }else{
            formComponent.initEleConfig({fieldArray:jsFieldArray,isDisabled:true,isClearValue:false,isShowDiv:false,isCanNull:false})
        }
    }
    if(initIsTreeFunc!=null){
        document.getElementById(eleMap.get('is_tree').getEleID()).removeEventListener('change', initIsTreeFunc);
    }
    initIsTreeFunc= ()=> {
        if(eleMap.get('is_tree').getValue()=='Y'){
            formComponent.initEleConfig({fieldArray:treeFieldArray,isDisabled:false,isClearValue:false,isShowDiv:true,isCanNull:true})
        }else{
            formComponent.initEleConfig({fieldArray:treeFieldArray,isDisabled:true,isClearValue:false,isShowDiv:false,isCanNull:false})
        }
    }
    initJsFileFunc= ()=>{
        if(eleMap.get('js_file').getValue().length>0){
            formComponent.initEleConfig({fieldArray:jsFieldArray,isDisabled:false,isClearValue:false,isShowDiv:true,isCanNull:false})
        }else{
            formComponent.initEleConfig({fieldArray:jsFieldArray,isDisabled:true,isClearValue:false,isShowDiv:false,isCanNull:false})
        }
    }


    //验证代码函数
    document.getElementById(eleMap.get('is_tree').getEleID()).addEventListener('change', initIsTreeFunc);
    document.getElementById(eleMap.get('js_file').getEleID()).addEventListener('input', initJsFileFunc);
}
functionMap.set('init', init);// 将函数添加到 Map 中

function initForm(eleMap){
}
let treeFieldArray=[
    'is_recursion','t_id','t_p_id','t_level'
];
let jsFieldArray=[
    'form_create','form_edit','form_detail'
];



